# Creates a playlist for a user

import pprint
import sys
import os
import subprocess

import spotipy

import util
import spotipy.oauth2 as oauth2


if len(sys.argv) > 2:
    username = sys.argv[1]
    playlist_name = sys.argv[2]
else:
    print "Usage: %s username playlist-name" % (sys.argv[0],)
    sys.exit()

token = util.prompt_for_user_token(username)

if token:
    sp = spotipy.Spotify(auth=token)
    sp.trace = False
    playlists = sp.user_playlist_create(username, playlist_name)
    pprint.pprint(playlists)
else:
    print "Can't get token for", username
